package com.jiuqi.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;
import java.io.StringReader;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

public final class JqLib {
   public static final String EMPTY_STRING = "";
   public static final String SQL_FALSE = "0";
   public static final String SQL_TRUE = "1";
   public static final char[] HEX_CHARS = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
   public static final char[] BASE64_CHARS = new char[]{'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '='};
   private static final int[] DAYS_IN_MONTH = new int[]{31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
   public static PrintStream testLogger = null;

   public static boolean isEmpty(String value) {
      return value == null || value.equals("");
   }

   public static boolean isBoolTrue(String sqlValue) {
      return sqlValue != null && (sqlValue.equals("1") || sqlValue.equalsIgnoreCase("T") || sqlValue.equalsIgnoreCase("TRUE"));
   }

   public static boolean isSymbol(String s) {
      if (s != null && s.length() != 0) {
         for(int i = 0; i < s.length(); ++i) {
            if (!Character.isLetterOrDigit(s.charAt(i)) && '_' != s.charAt(i)) {
               return false;
            }
         }

         return true;
      } else {
         return false;
      }
   }

   public static boolean isIdentifier(String s) {
      if (s != null && s.length() != 0) {
         for(int i = 0; i < s.length(); ++i) {
            if (!Character.isLetterOrDigit(s.charAt(i)) && '_' != s.charAt(i)) {
               return false;
            }
         }

         if (!Character.isLetter(s.charAt(0)) && '_' != s.charAt(0)) {
            return false;
         } else {
            return true;
         }
      } else {
         return false;
      }
   }

   public static boolean isNumberString(String s) {
      if (s != null && s.length() != 0) {
         for(int i = 0; i < s.length(); ++i) {
            if (!Character.isDigit(s.charAt(i))) {
               return false;
            }
         }

         return true;
      } else {
         return false;
      }
   }

   public static boolean hasSpaceChar(String s) {
      for(int i = 0; i < s.length(); ++i) {
         if (Character.isSpaceChar(s.charAt(i))) {
            return true;
         }
      }

      return false;
   }

   public static String convInput(String input) {
      try {
         return new String(input.getBytes("ISO8859_1"));
      } catch (Exception var1) {
         return input;
      }
   }

   public static String quoteString(String s) {
      return '"' + s + '"';
   }

   public static String quoteStringSingle(String s) {
      return "'" + s + "'";
   }

   public static String toFixedString(long iv, int width) {
      NumberFormat fmt = NumberFormatManager.createIntegerFormat(width);
      return fmt.format(iv);
   }

   public static String toFixedString(long iv, boolean seperator) {
      NumberFormat fmt = NumberFormatManager.createNumberFormat(0, seperator);
      return fmt.format(iv);
   }

   public static String replaceString(String s, String sub, String rep) {
      if (rep == null) {
         rep = "";
      }

      StringBuffer sb = new StringBuffer();
      int fromIndex = 0;
      int pos = false;

      int pos;
      do {
         pos = s.indexOf(sub, fromIndex);
         if (pos >= 0) {
            if (pos > fromIndex) {
               sb.append(s.substring(fromIndex, pos));
            }

            sb.append(rep);
            fromIndex = pos + sub.length();
         }
      } while(pos >= 0);

      if (fromIndex < s.length()) {
         sb.append(s.substring(fromIndex, s.length()));
      }

      return sb.toString();
   }

   public static String toFixedString(double value, boolean seperator) {
      NumberFormat fmt = new DecimalFormat();
      fmt.setGroupingUsed(seperator);
      return fmt.format(value);
   }

   public static String strExclude(String str, char ch) {
      if (str == null) {
         return null;
      } else {
         char[] chars = new char[str.length()];
         int index = 0;

         for(int i = 0; i < str.length(); ++i) {
            char c = str.charAt(i);
            if (c != ch) {
               chars[index++] = c;
            }
         }

         return new String(chars, 0, index);
      }
   }

   public static boolean charIsInCharSet(char value, char[] chrSet) {
      for(int i = 0; i < chrSet.length; ++i) {
         if (value == chrSet[i]) {
            return true;
         }
      }

      return false;
   }

   public static String strExclude(String str, char[] chs) {
      if (str == null) {
         return null;
      } else if (chs == null) {
         return str;
      } else {
         char[] chars = new char[str.length()];
         int index = 0;

         for(int i = 0; i < str.length(); ++i) {
            char c = str.charAt(i);
            if (!charIsInCharSet(c, chs)) {
               chars[index++] = c;
            }
         }

         return new String(chars, 0, index);
      }
   }

   public static String trimEx(String src) {
      StringBuffer ret = new StringBuffer(src);
      int i = ret.length() - 1;
      int size = src.length();
      if (size == 0) {
         return "";
      } else {
         for(; i >= 0; --i) {
            if (ret.charAt(i) == '\n' || ret.charAt(i) == '\r') {
               ret.deleteCharAt(i);
            }
         }

         return trim(ret.toString());
      }
   }

   public static String trim(String str) {
      if (str == null) {
         return null;
      } else {
         int s1 = -1;

         int s2;
         for(s2 = 0; s2 < str.length() && (str.charAt(s2) == ' ' || str.charAt(s2) == 12288); s1 = s2++) {
         }

         ++s1;
         s2 = str.length();

         for(int i = s2 - 1; i >= s1 && (str.charAt(i) == ' ' || str.charAt(i) == 12288); s2 = i--) {
         }

         if (s1 == 0 && s2 == str.length()) {
            return str;
         } else {
            return s1 >= s2 ? "" : str.substring(s1, s2);
         }
      }
   }

   public static String trimLeft(String str) {
      if (str == null) {
         return null;
      } else {
         int s1 = 0;

         int s2;
         for(s2 = 0; s2 < str.length() && str.charAt(s2) == ' '; s1 = s2++) {
         }

         s2 = str.length();
         if (s1 == 0) {
            return str;
         } else {
            return s1 >= s2 ? "" : str.substring(s1, str.length());
         }
      }
   }

   public static String trimRight(String str) {
      if (str == null) {
         return null;
      } else {
         int s2 = str.length();

         for(int i = s2 - 1; i >= 0 && str.charAt(i) == ' '; s2 = i--) {
         }

         if (s2 == str.length()) {
            return str;
         } else {
            return s2 <= 0 ? "" : str.substring(0, s2);
         }
      }
   }

   public static int compareString(String s1, String s2) {
      if (s1 == s2) {
         return 0;
      } else if (s1 == null) {
         return -1;
      } else {
         return s2 == null ? 1 : s1.compareTo(s2);
      }
   }

   public static int compareArray(int[] a1, int[] a2) {
      if (a1 == a2) {
         return 0;
      } else if (a1 == null) {
         return -1;
      } else if (a2 == null) {
         return 1;
      } else {
         int result = a1.length - a2.length;
         if (result != 0) {
            return result;
         } else {
            for(int i = 0; i < a1.length; ++i) {
               result = a1[i] - a2[i];
               if (result != 0) {
                  return result;
               }
            }

            return result;
         }
      }
   }

   public static String getLine(String text, int linenum) {
      if (text == null) {
         return "";
      } else {
         BufferedReader buffer = new BufferedReader(new StringReader(text));

         try {
            String line;
            for(line = null; linenum-- >= 0; line = buffer.readLine()) {
            }

            return line;
         } catch (IOException var4) {
            return text;
         }
      }
   }

   public static String encodePassword(String password, int maxlength) {
      int s1 = 97;
      int s2 = 76;
      int len = password == null ? 0 : password.length();
      if (len > maxlength) {
         len = maxlength;
      }

      StringBuffer pw = new StringBuffer(2 * maxlength);

      for(int i = 0; i < maxlength; ++i) {
         int ch = i < len && password != null ? password.charAt(i) : 0;
         ch = s1++ + ch ^ s2++;
         int ch1 = ch / 26 + 73;
         int ch2 = ch % 26 + 65;
         if ((i & 1) == 1) {
            s2 += ch1 & 15;
         } else {
            s2 -= ch1 & 15;
         }

         pw.append((char)ch1);
         pw.append((char)ch2);
      }

      return new String(pw);
   }

   public static String decodePassword(String password) {
      if (password == null) {
         return "";
      } else {
         int s1 = 97;
         int s2 = 76;
         int len = password.length() / 2;
         StringBuffer pw = new StringBuffer();

         for(int i = 0; i < len; ++i) {
            int ch1 = password.charAt(2 * i);
            int ch2 = password.charAt(2 * i + 1);
            int ch = (ch1 - 73) * 26 + (ch2 - 65);
            ch = (ch ^ s2++) - s1++;
            if (ch == 0) {
               break;
            }

            pw.append((char)ch);
            if ((i & 1) == 1) {
               s2 += ch1 & 15;
            } else {
               s2 -= ch1 & 15;
            }
         }

         return new String(pw);
      }
   }

   public static int[] stringToColRow(String str) {
      int[] pos = new int[]{0, 0};

      for(int i = 0; i < str.length(); ++i) {
         char ch = str.charAt(i);
         if (ch < 'A' || ch > 'Z') {
            try {
               pos[1] = Integer.parseInt(str.substring(i));
            } catch (NumberFormatException var4) {
               pos[1] = 0;
            }
            break;
         }

         pos[0] = pos[0] * 26 + (byte)ch - 65 + 1;
      }

      return pos[0] > 0 && pos[1] > 0 ? pos : null;
   }

   public static String colRowToString(int x, int y) {
      char[] chrArray = new char[64];

      int len;
      for(len = 0; x > 0; ++len) {
         char ch = (char)(x % 26 + 65 - 1);
         x /= 26;
         if (ch < 'A') {
            ch = 'Z';
            --x;
         }

         chrArray[len] = ch;
      }

      String colStr = "";

      for(int i = 0; i < len; ++i) {
         colStr = colStr + chrArray[len - i - 1];
      }

      return colStr + Integer.toString(y);
   }

   public static String makeHexString(int iv) {
      char[] buf = new char[8];

      int charPos;
      for(charPos = 7; iv != 0; iv >>>= 4) {
         buf[charPos--] = HEX_CHARS[iv & 15];
      }

      while(charPos >= 0) {
         buf[charPos--] = HEX_CHARS[0];
      }

      return new String(buf);
   }

   public static int parseHexValue(String hex) {
      return (int)Long.parseLong(hex, 16);
   }

   public static String bytesToHexString(byte[] data) {
      if (data == null) {
         return null;
      } else {
         StringBuffer result = new StringBuffer(data.length * 2);

         for(int i = 0; i < data.length; ++i) {
            int b = data[i];
            if (b < 0) {
               b += 256;
            }

            if (b < 16) {
               result.append('0');
            }

            result.append(Integer.toHexString(b));
         }

         return result.toString().toUpperCase();
      }
   }

   public static byte[] hexStringToBytes(String hexString) {
      if (hexString == null) {
         return null;
      } else {
         byte[] result = new byte[hexString.length() / 2];

         for(int i = 0; i < result.length; ++i) {
            result[i] = Integer.decode("0x" + hexString.substring(2 * i, 2 * i + 2)).byteValue();
         }

         return result;
      }
   }

   public static void listRevert(List list) {
      int high = list.size() - 1;

      for(int i = 0; i < list.size() / 2; ++i) {
         Object o = list.get(i);
         list.set(i, list.get(high - i));
         list.set(high - i, o);
      }

   }

   public static void listMove(List list, int index1, int index2) {
      Object t;
      int i;
      if (index1 > index2) {
         t = list.get(index1);

         for(i = index1; i > index2; --i) {
            list.set(i, list.get(i - 1));
         }

         list.set(index2, t);
      } else if (index1 < index2) {
         t = list.get(index1);

         for(i = index1; i < index2; ++i) {
            list.set(i, list.get(i + 1));
         }

         list.set(index2, t);
      }

   }

   public static int listFind(List items, Comparable item) {
      if (item == null) {
         return items.size() > 0 && items.get(0) == null ? 0 : -1;
      } else {
         int sb = 0;
         int se = items.size() - 1;
         int flag = -1;

         while(sb <= se) {
            int sp = sb + se >> 1;
            flag = item.compareTo(items.get(sp));
            if (flag > 0) {
               sb = sp + 1;
            } else {
               if (flag >= 0) {
                  sb = sp;
                  break;
               }

               se = sp - 1;
            }
         }

         return flag == 0 ? sb : -sb - 1;
      }
   }

   public static int listSortAdd(List items, Object item) {
      int index = listFind(items, (Comparable)item);
      if (index < 0) {
         index = -index - 1;
         items.add(index, item);
      }

      return index;
   }

   public static void listSort(List items) {
      if (items.size() > 1) {
         listQuickSort(items, 0, items.size() - 1);
      }

   }

   protected static void listQuickSort(List items, int left, int right) {
      int i;
      do {
         i = left;
         int j = right;
         Comparable item = (Comparable)items.get(left + right >> 1);

         do {
            while(item.compareTo(items.get(i)) > 0) {
               ++i;
            }

            while(item.compareTo(items.get(j)) < 0) {
               --j;
            }

            if (i <= j) {
               Object o = items.get(i);
               items.set(i, items.get(j));
               items.set(j, o);
               ++i;
               --j;
            }
         } while(i <= j);

         if (left < j) {
            listQuickSort(items, left, j);
         }

         left = i;
      } while(i < right);

   }

   public static byte[] stringToBytes(String s) {
      return s == null ? null : s.getBytes();
   }

   public static String bytesToString(byte[] b) {
      return b == null ? null : new String(b);
   }

   public static boolean isLeapYear(int AYear) {
      return AYear % 4 == 0 && (AYear % 100 != 0 || AYear % 400 == 0);
   }

   public static int daysPerMonth(int AYear, int AMonth) {
      return AMonth == 2 && isLeapYear(AYear) ? DAYS_IN_MONTH[AMonth] + 1 : DAYS_IN_MONTH[AMonth];
   }

   public static Calendar dayTermToDate(int AYear, int Term) {
      Calendar result = new GregorianCalendar();
      result.setTime(new Date(0L));
      result.set(AYear, 1, 1);
      if (Term <= 0) {
         Term = 1;
      }

      for(int I = 1; I <= 12; ++I) {
         if (Term <= daysPerMonth(AYear, I)) {
            result.set(AYear, I, Term);
            break;
         }

         Term -= daysPerMonth(AYear, I);
      }

      return result;
   }

   public static String getFileName(String name) {
      String returnStr = StringUtils.replace(name, "/", "");
      returnStr = StringUtils.replace(returnStr, "\\", "");
      returnStr = StringUtils.replace(returnStr, ":", "");
      returnStr = StringUtils.replace(returnStr, "\"", "");
      returnStr = StringUtils.replace(returnStr, ">", "");
      returnStr = StringUtils.replace(returnStr, "<", "");
      returnStr = StringUtils.replace(returnStr, "|", "");
      returnStr = StringUtils.replace(returnStr, "?", "");
      returnStr = StringUtils.replace(returnStr, "*", "");
      return returnStr;
   }

   public static String getChinaNumberTitle(int value) {
      switch (value) {
         case 0:
            return "零";
         case 1:
            return "一";
         case 2:
            return "二";
         case 3:
            return "三";
         case 4:
            return "四";
         case 5:
            return "五";
         case 6:
            return "六";
         case 7:
            return "七";
         case 8:
            return "八";
         case 9:
            return "九";
         case 10:
            return "十";
         default:
            return "一";
      }
   }

   public static void main(String[] args) {
      String s = "孙建卫";
      byte[] b = stringToBytes(s);
      System.out.println(b);
      s = bytesToString(b);
      System.out.println(s);
      System.out.println();
   }
}
